﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference=true)]
    class Abonnement : IAbonnement
    {
        internal Abonnement(string betalingsform, float rabatsats, IBlad bladet, IKunde kunden)    // constructor
        {
            this.Betalingsform = betalingsform;
            this.Rabatsats = rabatsats;

            this.bladet = bladet;       // tilknyt
            this.kunden = kunden;       // tilknyt

            (this.bladet as Blad).AssocierAbonnement(this);   // sørg også for tylknytning fra bladet / kunden antages selv at gøre det
        }

        internal void SletAbonnementData()         // kaldes før sletning for at rydde korrekt op - forbindelse til kunden forventes at være klarer der
        {
            (this.bladet as Blad).DisAssocierAbonnement(this);
        }

        public override string ToString()
        {
            return "" + this.Betalingsform + "; " + this.Rabatsats + "; " + this.kunden.Navn + "; " + this.bladet.BladNavn;
        }

        #region selve abonnementes data og metoder fra domain beskrivelsen

        [DataMember]
        public string Betalingsform { get; private set; }
        [DataMember]
        public float Rabatsats { get; private set; }

        public void RetStamdata(string betalingsform, float rabatsats)
        {
            this.Betalingsform = betalingsform;
            this.Rabatsats = rabatsats;
        }

        #endregion

        #region forbindelser til tilknyttede kunde og blad

        [DataMember]
        private IKunde kunden;

        [DataMember]
        private IBlad bladet;

        public IKunde FindKunden()
        {
            return this.kunden;
        }

        public IBlad FindBladet()
        {
            return this.bladet;
        }

        #endregion


    }
}
