﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    [KnownType(typeof(Blad))]
    class BladKartotek : IBladKartotek
    {
        [DataMember]
        private List<IBlad> alleBladene = new List<IBlad>();

        public IBlad OpretBlad(string navn, string udgivelsesfrekvens)
        {
            Blad nyBlad = new Blad(navn,udgivelsesfrekvens);
            this.alleBladene.Add(nyBlad);
            return nyBlad;
        }

        public void SletBlad(IBlad valgtBlad)
        {
            (valgtBlad as Blad).SletBladData();
            this.alleBladene.Remove(valgtBlad as Blad);
        }

        public List<IBlad> FindAlleBlade()
        {
            return new List<IBlad>(this.alleBladene);       // vigtigt - ny liste med alle
        }

        public IBlad FindBladMedNavn(string valgtNavn)
        {
            valgtNavn = valgtNavn.ToLower();
            foreach (IBlad etBlad in alleBladene)
            {
                if (etBlad.BladNavn.ToLower() == valgtNavn)
                    return etBlad;
            }
            return null;
        }

        public List<IBlad> FindAlleMedUdgivelsesFrekvens(string valgtUdgivelsesfrekvens)
        {
            valgtUdgivelsesfrekvens = valgtUdgivelsesfrekvens.Trim().ToLower();
            List<IBlad> fundneBlade = new List<IBlad>();
            foreach (IBlad etBlad in alleBladene)
            {
                if (etBlad.Udgivelsesfrekvens.ToLower() == valgtUdgivelsesfrekvens)
                    fundneBlade.Add(etBlad);
            }
            return fundneBlade;
        }
    }
}
