﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;
using System.IO;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    [KnownType(typeof(BladKartotek))]
    [KnownType(typeof(KundeKartotek))]
    public class Bladhus : IBladhus        // Der samles i eet objekt af hensyn til let serialisering
    {
        [DataMember]
        public IKundeKartotek Kundekartoteket { get; private set; }
        [DataMember]
        public IBladKartotek Bladkartoteket { get; private set; }

        public  Bladhus()
        {
            this.Kundekartoteket = new KundeKartotek();
            this.Bladkartoteket = new BladKartotek();
        }
        public void SaveBladhus(Stream outStream)
        {
            DataContractSerializer serializer = new DataContractSerializer(typeof(Bladhus)); 
            serializer.WriteObject(outStream, this);
        }

        public static IBladhus LoadBladhus(Stream inStream)
        {
            DataContractSerializer serializer = new DataContractSerializer(typeof(Bladhus));
            return serializer.ReadObject(inStream) as Bladhus;
        }
    }
}
