﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BladhusInterfaceLibrary;
using System.Runtime.Serialization;

namespace BladhusClassLibrary
{
    [DataContract(IsReference = true)]
    [KnownType(typeof(Kunde))]
    class KundeKartotek : IKundeKartotek
    {
        [DataMember]
        private List<IKunde> alleKunderne = new List<IKunde>();

        public IKunde OpretKunde(int kundenr, string navn, string gade, string postnr, string postby, string email)
        {
            Kunde nyKunde = new Kunde(kundenr, navn, gade, postnr, postby, email);
            this.alleKunderne.Add(nyKunde);
            return nyKunde;
        }

        public void SletKunde(IKunde valgtKunde)
        {
            (valgtKunde as Kunde).SletKundeData();
            this.alleKunderne.Remove(valgtKunde as Kunde);
        }

        public List<IKunde> FindAlleKunder()
        {
            return new List<IKunde>(this.alleKunderne);         // ny liste med alle
        }

        public IKunde FindKundeMedKundenr(int valgtKundenr)
        {
            foreach (IKunde enKunde in alleKunderne)
            {
                if (enKunde.Kundenr == valgtKundenr)
                    return enKunde;
            }
            return null;
        }

        public IKunde FindKundeMedEmail(string valgtEmail)
        {
            valgtEmail = valgtEmail.Trim().ToLower();
            foreach (IKunde enKunde in alleKunderne)
            {
                if (enKunde.Email.ToLower() == valgtEmail)
                    return enKunde;
            }
            return null;
        }

        public List<IKunde> FindKunderMedNavn(string valgtNavn)
        {
            valgtNavn = valgtNavn.Trim().ToLower();
            List<IKunde> fundneKunder = new List<IKunde>();
            foreach (IKunde enKunde in alleKunderne)
            {
                if (enKunde.Navn.ToLower().IndexOf(valgtNavn) >= 0)
                    fundneKunder.Add(enKunde);
            }
            return fundneKunder;
        }
    }
}
